searchNodes=[{"doc":"Shared inter-process queue.","ref":"shq.html","title":"shq","type":"module"},{"doc":"Closes an open queue in order to reject subsequent and waiting inserts. A closed queue can be reopened with a call to open/1 . See also: in/2 , in/3 , in_r/2 , in_r/3 , open/1 , status/1 .","ref":"shq.html#close/1","title":"shq.close/1","type":"function"},{"doc":"Drain the queue from the front.","ref":"shq.html#drain/1","title":"shq.drain/1","type":"function"},{"doc":"Drain the queue from the rear.","ref":"shq.html#drain_r/1","title":"shq.drain_r/1","type":"function"},{"doc":"Insert an item at the rear of a queue immediately.","ref":"shq.html#in/2","title":"shq.in/2","type":"function"},{"doc":"Insert an item at the rear of a queue, waiting for the given timeout if the queue is full.","ref":"shq.html#in/3","title":"shq.in/3","type":"function"},{"doc":"Insert an item at the front of a queue immediately.","ref":"shq.html#in_r/2","title":"shq.in_r/2","type":"function"},{"doc":"Insert an item at the front of a queue, waiting for the given timeout if the queue is full.","ref":"shq.html#in_r/3","title":"shq.in_r/3","type":"function"},{"doc":"Opens a closed queue to accept subsequent inserts. See also: close/1 , in/2 , in/3 , in_r/2 , in_r/3 , status/1 .","ref":"shq.html#open/1","title":"shq.open/1","type":"function"},{"doc":"Retrieve and remove an item from the front of a queue immediately.","ref":"shq.html#out/1","title":"shq.out/1","type":"function"},{"doc":"Retrieve and remove an item from the front of a queue, waiting for the given timeout if the queue is empty.","ref":"shq.html#out/2","title":"shq.out/2","type":"function"},{"doc":"Retrieve and remove an item from the rear of a queue immediately.","ref":"shq.html#out_r/1","title":"shq.out_r/1","type":"function"},{"doc":"Retrieve and remove an item from the rear of a queue, waiting for the given timeout if the queue is empty.","ref":"shq.html#out_r/2","title":"shq.out_r/2","type":"function"},{"doc":"Retrieve an item from the front of a queue without removing it.","ref":"shq.html#peek/1","title":"shq.peek/1","type":"function"},{"doc":"Retrieve an item from the rear of a queue without removing it.","ref":"shq.html#peek_r/1","title":"shq.peek_r/1","type":"function"},{"doc":"Get the number of items currently in a queue.","ref":"shq.html#size/1","title":"shq.size/1","type":"function"},{"doc":"Start an non-linked anonymous queue.","ref":"shq.html#start/1","title":"shq.start/1","type":"function"},{"doc":"Start an non-linked named queue.","ref":"shq.html#start/2","title":"shq.start/2","type":"function"},{"doc":"Start an linked anonymous queue.","ref":"shq.html#start_link/1","title":"shq.start_link/1","type":"function"},{"doc":"Start an linked named queue.","ref":"shq.html#start_link/2","title":"shq.start_link/2","type":"function"},{"doc":"Start an monitored anonymous queue.","ref":"shq.html#start_monitor/1","title":"shq.start_monitor/1","type":"function"},{"doc":"Start an monitored named queue.","ref":"shq.html#start_monitor/2","title":"shq.start_monitor/2","type":"function"},{"doc":"Get the queue status, which is either open or closed . See also: close/1 , open/1 .","ref":"shq.html#status/1","title":"shq.status/1","type":"function"},{"doc":"Stop a queue. All remaining items will be discarded.","ref":"shq.html#stop/1","title":"shq.stop/1","type":"function"},{"doc":"Queue options, either a map or proplist.","ref":"shq.html#t:opts/0","title":"shq.opts/0","type":"type"},{"doc":"","ref":"shq.html#t:opts_list/0","title":"shq.opts_list/0","type":"type"},{"doc":"","ref":"shq.html#t:opts_map/0","title":"shq.opts_map/0","type":"type"},{"doc":"See gen_server:start/3,4, gen_server:start_link/3,4, gen_server:start_monitor/3,4.","ref":"shq.html#t:server_name/0","title":"shq.server_name/0","type":"type"},{"doc":"See gen_server:call/3,4, gen_server:cast/2.","ref":"shq.html#t:server_ref/0","title":"shq.server_ref/0","type":"type"},{"doc":":link: Hex package shq requires OTP 24 or later.","ref":"readme.html","title":"shq - Shared inter-process queues","type":"extras"},{"doc":"Starting a queue %% Start a non-linked queue { ok , Pid } = shq : start ( Opts ) . { ok , Pid } = shq : start ( ServerName , Opts ) . %% Start a linked queue { ok , Pid } = shq : start_link ( Opts ) . { ok , Pid } = shq : start_link ( ServerName , Opts ) . %% Start a monitored queue { ok , { Pid , Mon } } = shq : start_monitor ( Opts ) . { ok , { Pid , Mon } } = shq : start_monitor ( ServerName , Opts ) . ServerName A server name as used when starting a named gen_server . Opts A map or property list of options max => non_neg_integer() | infinity The maximum number of items the queue can hold (default: infinity ). Inserting an item %% Insert an item at the rear shq : in ( ServerRef , Item ) . shq : in ( ServerRef , Item , Timeout ) . %% Insert an item at the front shq : in_r ( ServerRef , Item ) . shq : in_r ( ServerRef , Item , Timeout ) . ServerRef A server reference as used with gen_server . Item The item to insert. Timeout A timeout to wait for a slot to become available if the queue is full (default: 0 ). The return value is either the atom ok if the item was queued, the atom full if the queue was full, or the atom closed if the queue was not accepting new items at the time of the call. When these functions return full or closed , it is guaranteed that the given item was not inserted, and will not be inserted later without calling this function again. Retrieving an item %% Retrieving an item from the front shq : out ( ServerRef ) . shq : out ( ServerRef , Timeout ) . %% Retrieving an item from the rear shq : out_r ( ServerRef ) . shq : out_r ( ServerRef , Timeout ) . ServerRef See \"Inserting\". Timeout A timeout to wait for an item to become available if the queue is empty (default: 0 ). The return value is either a tuple {ok, Item} , or the atom empty . When these functions return empty , it is guaranteed that no item was removed from the queue, and none will be removed later without calling this function again. Peeking %% Peek at the front shq : peek ( ServerRef ) . %% Peek at the rear shq : peek_r ( ServerRef ) . ServerRef See \"Inserting\". Peeking is the same as retrieving, but without removing the item from the queue. The operation will always return instantly, ie there is no way to wait for an item to become available if the queue is empty. Draining a queue %% Draining a quee from the front shq : drain ( ServerRef ) . %% Draining a queue from the rear shq : drain_r ( ServerRef ) . ServerRef See \"Inserting\". The return value is a list of all items that were in the queue at the time when the call was made, including the ones that were waiting for insertion. Retrieving queue size shq : size ( ServerRef ) . ServerRef See \"Inserting\". Retrieves the number of items in the queue. The return value is a non-negative integer. Closing and Reopening a queue %% Closing a queue ok = shq : close ( ServerRef ) . %% Reopening a queue ok = shq : open ( ServerRef ) . ServerRef See \"Inserting\". When a queue is closed, all subsequent insert operations will be rejected and return closed until it is reopened. The queue status can be queried via shq:status(ServerRef) . Stopping a queue ok = shq : stop ( ServerRef ) . ServerRef See \"Inserting\". All items left will be lost when a queue is stopped.","ref":"readme.html#usage","title":"shq - Shared inter-process queues - Usage","type":"extras"},{"doc":"As shq queues are backed by ets tables of type set , the number of items in a queue does not affect its performance. However, as ets tables live in memory, shq queues are not suitable for storing vast numbers of large items. It is also noteworthy that items waiting to be inserted into a queue that is currently full will still be stored in the backing table, albeit temporarily, and thus still against available memory.","ref":"readme.html#notes","title":"shq - Shared inter-process queues - Notes","type":"extras"},{"doc":"Maria Scott (Maria-12648430) Jan Uhlig (juhlig)","ref":"readme.html#authors","title":"shq - Shared inter-process queues - Authors","type":"extras"},{"doc":"Copyright (c) 2022, Maria Scott &lt;maria-12648430@hnc-agency.org&gt; Copyright (c) 2022, Jan Uhlig &lt;juhlig@hnc-agency.org&gt; Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies. THE SOFTWARE IS PROVIDED &quot;AS IS&quot; AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]